library(mamlr)
load('/home/2917550/no_nb_junk_Recall.RData')
args = commandArgs(trailingOnly=TRUE)
es_super <- args[2]
es_pwd <- args[1]
query <- paste0('{"query": {"bool": {"filter":[{"term":{"country": "',country,'"}}]}}}')
dfm_words <- corpus(paste(colnames(model_final$PwGc), collapse = ' '), docnames = c(1)) %>%
  dfm(tolower = T, stem = F, remove_punct = T, valuetype = "regex", ngrams = 1)

### Generate dfm based on words in model, to subset the features of the target dfm
updater <- function(out, model_final, dfm_words, varname, es_super) {
  print('updating')
  dfm <- dfm_gen(out, text = 'lemmas') %>%
    dfm_keep(dfm_words, valuetype="fixed", verbose=T)
  pred <- data.frame(id = out$`_id`, pred = predict(model_final, newdata = dfm))
  bulk <- apply(pred, 1, bulk_writer, varname = varname)
  res <- elastic_update(bulk, es_super = es_super)
  stop_for_status(res)
  content(res, "parsed", "application/json")
  appData <- content(res)
  if (appData$errors == T){
    print(appData)
    stop("Aborting, errors found during updating")
  }
  print("updated")
}
out <- elasticizer(query, src = T, es_pwd = es_pwd, update = updater, 
                   model_final = model_final, dfm_words = dfm_words, varname = 'computerCodes.junk', es_super = es_super)
print(out)
